---
title: AudioContext.createJavaScriptNode()
slug: Web/API/AudioContext/createJavaScriptNode
tags:
  - API
  - Audio
  - Method
  - Obsolete
  - Reference
  - Web
  - createJavaScriptNode
---
<p>{{APIRef("Web Audio API")}}{{obsolete_header}}</p>

<div class="summary">
<p>The <code>AudioContext.createJavaScriptNode()</code> method creates a {{domxref("JavaScriptNode")}} which is used for directly manipulating audio data with JavaScript.</p>
</div>

<div class="note">
<p><strong>Important</strong>: This method is obsolete, and has been renamed to {{domxref("AudioContext.createScriptProcessor()")}}. See also {{domxref("ScriptProcessorNode")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var jsNode = <code><em>audioCtx</em>.createJavaScriptNode(<em>bufferSize</em>, <em>numInputChannels</em>, <em>numOutputChannels</em>);</code>
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>bufferSize</code></dt>
 <dd>The buffer size must be in units of sample frames, i.e., one of: 256, 512, 1024, 2048, 4096, 8192, or 16384. It controls the frequency of callbacks asking for a buffer refill. Smaller sizes allow for lower latency and higher for better overall quality.</dd>
 <dt><code>numInputChannels</code></dt>
 <dd>The number of input channels in the audio stream.</dd>
 <dt><code>numOutputChannels</code></dt>
 <dd>The number of output channels in the audio stream.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following script illustrates the use of <code>createJavaScriptNode()</code>:</p>

<pre class="brush: js">var SineWave = function(context) {
  var that = this;
  this.x = 0; // Initial sample number
  this.context = context;
  this.node = context.createJavaScriptNode(1024, 1, 1);
  this.node.onaudioprocess = function(e) { that.process(e) };
}

SineWave.prototype.process = function(e) {
  var data = e.outputBuffer.getChannelData(0);
  for (var i = 0; i &lt; data.length; ++i) {
    data[i] = Math.sin(this.x++);
  }
}

SineWave.prototype.play = function() {
  this.node.connect(this.context.destination);
}

SineWave.prototype.pause = function() {
  this.node.disconnect();
}
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://0xfe.blogspot.com/2011/08/generating-tones-with-web-audio-api.html">Generating Tones with the Web Audio API</a></li>
 <li><a href="http://www.smartjava.org/content/exploring-html5-web-audio-visualizing-sound">Exploring the HTML5 Web Audio: visualizing sound</a></li>
</ul>
